#include "thread.h"

thread	*Threads;
int	ThCurr = 1;
static int	N_Threads;
static int	Free = 2;
static int	Next = 1;
static char	*Stack;
static void (*Root)(void);

thread *
ThInit (n, size)
int n, size;
{
	int	i;

	if (!N_Threads) {
		if (n < 2)
			return 0;

		Threads = (thread * )calloc(n, sizeof (thread));
		if (!Threads)
			return Threads;
		Threads--;
		N_Threads = n, n = 1;
		if (setjmp(Threads[1].exit))
			exit(0);
	} else if (!Stack) {
		Stack = (char *) &size;
		if (setjmp(Threads[n].exec)) {
			if (!setjmp(Threads[ThCurr].exit))
				(*Root)();
			Threads[ThCurr].free = Free;
			Free = ThCurr;
			Next = Threads[Free].next;
			for (i = 1; i <= N_Threads; i++) {
				if (Threads[i].parent == Free)
					Threads[i].parent = 1;
				if (Threads[i].next == Free)
					Threads[i].next = Threads[Free].next;
			}
			ThCurr = Threads[Free].parent;
			Threads[Free].parent = 0;
			longjmp(Threads[ThCurr].jump, Free);
		}
	}
	if (Stack - (char *) &size < size)
		ThInit(n, size);
	else {
		Threads[n].stack = (char *) & size;
		Stack = 0;
		if (n < N_Threads) {
			Threads[n].free = n + 1;
			ThInit(++n, size);
		} else
			Threads[n].free = 0;
	}
	return Threads;
}


void
ThFree()
{
	free(Threads + 1);
	Threads = 0, N_Threads = 0;
}


int
ThNew(void (*root)(void))
{
	int	parent, forke;

	ThProbe();
	forke = Free;
	if (forke == 0)
		return - 1;
	Free = Threads[forke].free;
	parent = ThCurr;
	Threads[forke].parent = parent;
	ThCurr = forke;
	if (!Threads[Next].next)
		Threads[ThCurr].next = Next;
	else
		Threads[ThCurr].next = Threads[Next].next;
	Threads[Next].next = ThCurr;
	Next = ThCurr;
	if (setjmp(Threads[parent].jump))
		return forke;
	Root = root;
	longjmp(Threads[ThCurr].exec, forke);
}


void
ThExit()
{
	ThProbe();
	longjmp(Threads[ThCurr].exit, ThCurr);
}


int
ThJump(id)
int	id;
{
	int	jumper, caller;

	ThProbe();

	if (id == 0)
		id = Threads[ThCurr].next;
	if (id < 1 || id > N_Threads || Threads[id].parent < 0)
		return - 1;
	caller = ThCurr;
	if (id == caller)
		return ThCurr;
    ThCurr = id;
	if (jumper = setjmp(Threads[caller].jump))
		return jumper;
	longjmp(Threads[id].jump, caller);
}


static void
test()
{
	ThProbe();
	printf("test: called from thread %d\n", ThId());
	ThJump(0);
	printf("test: falling off thread %d\n", ThId());
}


main()
{
	int	i;
	ThInit(3, 2048);

	for (i = 1; i <= 9; i++) {
		printf("main: loop %d\n", i);
		printf("main: created new thread % d\n", ThNew(test));
		printf("main: created new thread %d\n", ThNew(test));
		printf("main: exited from thread % d\n", ThJump(0));
		printf("main: exited from thread %d\n", ThJump(0));
	}
}


